
public class PQueue
{
    ListNode list = null;

    public void insert(TreeNode t){ // inserts a new treenode 
        ListNode l = new ListNode();
        l.hufftree = t;
        l.next = list;
        list = l;
    }

    public void buildList(Character[] chars, int n){ //builds the list from the Character table, will be provided later
        TreeNode tNode;
        for(int i = 0; i < n; i++){
            tNode = new TreeNode();
            tNode.nodeProb = chars[i].charProb;
            tNode.left = null;
            tNode.right = null;
            tNode.theChar = chars[i].theChar;
            tNode.huffNum = "";
            insert(tNode);
        }
    }

    public void printList(){ //prints out list contents
        System.out.println("List Contents ----->");
        ListNode l = list;
        while (l != null) {
            System.out.print("Char: " + l.hufftree.theChar);
            System.out.println(", Prob: " + l.hufftree.nodeProb);
            l = l.next;
        }
        System.out.println("----> End");

    }

    public TreeNode getLeast(){
        ListNode l = null; //to keep track of current node
        ListNode oldl = null;  //previous node
        ListNode minl = null;  //node with lowest prob
        ListNode oldminl = null;  //previous node with lowest prob
        double minw = 1000000; //min weight
        oldl = list; //to start, previous node is list
        l = list; //sets current node to list
        while( l != null){
            if(l.hufftree.nodeProb < minw){ //keeps setting the lowest node found as long as new weight is lower than previous
                minw = l.hufftree.nodeProb; //this should always run for first node
                oldminl = oldl; //sets oldmin
                minl = l; //sets minl to current node
            }

            oldl = l; 
            l = l.next; // moves to next node
        }
        if (minl == oldminl){ //sometimes may be equal
            list = list.next;
            return minl.hufftree;
        }
        oldminl.next = minl.next;
        return minl.hufftree;

    }

}

