import java.util.*;
import java.io.*;
import java.text.DecimalFormat;
class ProbList {
   public final int maxCharNum = 100; // maximum number of chars
   public int listSize; // current size of list
   public Character[] probs; // array of Characters
   private Reader in; // for reading in file
   String file = ""; // read in file as string
   private boolean isOpen = false; // is file open true/false
   public String fileName; // name of original file
   private int charsRead = 0; // total number of chars read
   char markerChar = '@'; // sentinal at end of file REMOVE IF NOT NEEDED
   public DecimalFormat fourDigits = new DecimalFormat("0.0000"); //restricts to four decimal places

   // Sets file name, creates probability list
   public ProbList(String f) {
      fileName = f;
      listSize = 0;
      probs = new Character[maxCharNum];
   } 

   // prints out list contents
   public void printList() {
      int i;
      System.out.println("List Contents ----->");
      System.out.println("  Size: " + listSize);
      for (i = 0; i < listSize; i++) {
         System.out.println("Character # " + i + ": Symbol- " +
            probs[i].theChar + ", Probability: " + fourDigits.format(probs[i].charProb) +
            ", Huffman Number: " + probs[i].huffNum);
      }
      System.out.println("----> End ");
   }

   // opens file, gets the next char
   private char nextChar() {
      char ch = ' ';
      if (!isOpen) {
         isOpen = true;
         if (fileName == null)
            in = new InputStreamReader(System.in);
         else {
            try {
               in = new FileReader(fileName);
            } catch (IOException e) {  //makes sure to catch strange exceptions, keeps compiler happy
               System.out.println("YOU HAVE FAILED TO OPEN " + fileName);
               for(int i = 0; i < 30; i++){
               System.out.println("THE CAKE IS A LIE THE CAKE IS A LIE THE CAKE IS A LIE");
            }
            }
         }
      }
      try {
         ch = (char)in.read();
      } catch (IOException e) {
         System.out.println("Exception reading character");
      }
      return ch;
   }

   // gets character and adds to the list
   public void setListValues() {
      char ch = nextChar();
      while (ch != 65535 && ch != markerChar) { // just to catch strange errors
         charsRead++;
         file += ch;
         int i = findNextChar(ch);
         if (i == -1) { // new Character for probs list
            probs[listSize] = new Character();
            probs[listSize].theChar = ch;
            probs[listSize].charProb = 1.0;
            probs[listSize].huffNum = "";
            listSize++;
         }
         else { // this Character is in the list already
            probs[i].charProb += 1.0;
         }
         ch = nextChar();
      } 
      // finish calculating the charProbs
      for (int j = 0; j < listSize; j++){
         probs[j].charProb /= (double)charsRead;
        }

   }
   
   // finds the next char in the list probs
   public int findNextChar(char ch) {
      for (int j = 0; j < listSize; j++)
         if (probs[j].theChar == ch) return j;
      return -1;
   }
}